---
title: Map.prototype.forEach()
slug: Web/JavaScript/Reference/Global_Objects/Map/forEach
tags:
  - ECMAScript 2015
  - JavaScript
  - Map
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p><span class="seoSummary">The <strong><code>forEach()</code></strong> method executes a provided function once per each key/value pair in the <code>Map</code> object, in insertion order.</span></p>

<div>{{EmbedInteractiveExample("pages/js/map-prototype-foreach.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>myMap</var>.forEach(<var>callback</var>([<var>value</var>][, <var>key</var>][, <var>map</var>])[, <var>thisArg</var>])</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code><var>callback</var></code></dt>
 <dd>
 <p>Function to execute for each entry of <code><var>myMap</var></code>. It takes the following arguments:</p>

 <dl>
  <dt><code><var>value</var></code> {{Optional_Inline}}</dt>
  <dd>Value of each iteration.</dd>
  <dt><code><var>key</var></code> {{Optional_Inline}}</dt>
  <dd>Key of each iteration.</dd>
  <dt><code><var>map</var></code> {{Optional_Inline}}</dt>
  <dd>The map being iterated (<code><var>myMap</var></code> in the above Syntax box).</dd>
 </dl>
 </dd>
 <dt><code><var>thisArg</var></code> {{Optional_Inline}}</dt>
 <dd>Value to use as <code>this</code> when executing <code><var>callback</var></code>.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref("undefined")}}.</p>

<h2 id="Description">Description</h2>

<p>The <code>forEach</code> method executes the provided <code><var>callback</var></code> once for each key of the map which actually exist. It is not invoked for keys which have been deleted. However, it is executed for values which are present but have the value <code>undefined</code>.</p>

<p><code><var>callback</var></code> is invoked with <strong>three arguments</strong>:</p>

<ul>
 <li>the entry's <code><var>value</var></code></li>
 <li>the entry's <code><var>key</var></code></li>
 <li>the <strong><code>Map</code> object</strong> being traversed</li>
</ul>

<p>If a <code><var>thisArg</var></code> parameter is provided to <code>forEach</code>, it will be passed to <code><var>callback</var></code> when invoked, for use as its <code>this</code> value. Otherwise, the value <code>undefined</code> will be passed for use as its <code>this</code> value. The <code>this</code> value ultimately observable by <code><var>callback</var></code> is determined according to <a href="/en-US/docs/Web/JavaScript/Reference/Operators/this">the usual rules for determining the <code>this</code> seen by a function</a>.</p>

<p>Each value is visited once, except in the case when it was deleted and re-added before <code>forEach</code> has finished. <code><var>callback</var></code> is not invoked for values deleted before being visited. New values added before <code>forEach</code> has finished will be visited.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Printing_the_contents_of_a_Map_object">Printing the contents of a Map object</h3>

<p>The following code logs a line for each element in an <code>Map</code> object:</p>

<pre class="brush:js notranslate">function logMapElements(value, key, map) {
    console.log(`map.get('${key}') = ${value}`)
}
new Map([['foo', 3], ['bar', {}], ['baz', undefined]]).forEach(logMapElements)
// logs:
// "map.get('foo') = 3"
// "map.get('bar') = [object Object]"
// "map.get('baz') = undefined"
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-map.prototype.foreach', 'Map.prototype.forEach')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Map.forEach")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Array.prototype.forEach()")}}</li>
 <li>{{jsxref("Set.prototype.forEach()")}}</li>
</ul>
